/*
 *  Copyright 2010 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.cms.tool.profile');

org.ametys.cms.tool.profile.ProfileContextButton = function(id, configuration, pluginName) 
{
	org.ametys.cms.tool.profile.ProfileContextButton.superclass.constructor.call(this, id, configuration, pluginName);
};

Ext.extend(org.ametys.cms.tool.profile.ProfileContextButton, org.ametys.ribbon.control.button.ActionButton, {});

/**
 * @private
 * @property _lastParams The params received on the last refresh
 */
org.ametys.cms.tool.profile.ProfileContextButton.prototype._lastParams;

/**
 * @private
 * @property {String[]} _currentGroupsId The groups' id currently selected or null. 
 */
org.ametys.cms.tool.profile.ProfileContextButton.prototype._currentGroupsId;

org.ametys.cms.tool.profile.ProfileContextButton.prototype.onMessage = function (messages)
{
	// SELECTION
	for (var i=messages.length - 1; i >= 0; i--)
	{
		if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED)
		{
			var targets = messages[i].getTargets();
			var allTargets = this._searchProfileTarget(targets);
			
			// No content selected
			if (allTargets.length == 0)
			{
				this.getElements().each(function(element) { element.disable(); });
			}
			else
			{
				this.getElements().each(function(element) { element.enable(); });
			}
			
			return;
		}
	}
}

// FIXME replace with a findAll helper with a _convertId method (search all js for a sample)
org.ametys.cms.tool.profile.ProfileContextButton.prototype._searchProfileTarget = function(targets)
{
	var allTargets = [];
	for (var i=0; i < targets.length; i++)
	{
		if (targets[i].getType() == "profile" && targets[i].getParameters().context)
		{
			allTargets.push(targets[i].getParameters()['id']);
		}
		
		var subSearch = this._searchProfileTarget(targets[i].getSubTargets());
		allTargets = allTargets.concat(subSearch);
	}
	return allTargets;
}




